/* yasep/tool/yasim.js
 created ven. oct.  5 06:38:36 CEST 2012 by whygee@f-cpu.org
 lun. oct.  8 21:49:12 CEST 2012 : renamed from simul.js
 sam. oct. 13 06:14:28 CEST 2012 moved adjustHeight to its own files

todo : flags

*/
/*
blackList("BPcycle_id");
blackList("BPaddr_id");
blackList("BPvalReg_id");
blackList("BPopc_id");
blackList("Carry_id");
blackList("Zero_id");
*/
/*
function tagFocus(){
  ygwm.focus_window(null,this.win);
  return false;
}
*/

////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////

init_obj.push(sim={

  simCount:1,

///////////// floating cursor :
  create_cursor: function(col,cont,omd,w){
    var c=dcE("DIV");
    c.ed=null; // not linked yet.
    c.win=w;  // The "sim" window that it is linked with
    c.className="tag";
    c.style.color=col;
    c.innerHTML=cont+"\u25B6";
    c.onmousedown=omd;
    return c;
  },

///////////// Finite State Machine :
  states:["INIT", "STEP", "RUN", "STOP", "HALT", "FAULT", "DISCONNECTED"], // TODO : TRAP
  // The actual state is a number stored in win.state

  changeState: function(w,n) {
    // display trace
    sim.logLine(w);

    w.shortmsg("&nbsp;"+I8N("St")+"&nbsp;<i>"
      +sim.states[w.state
         =n]+"</i>");
    w.arrowDiv.style.display=(n<6)?"block":"none";

    if ((n>4) && w.arrow.ed) // if fault or disconnected,
      YASMed.unlinkArrow(w);  // take the arrow home
  },

  resetState: function(w,s) { // s is a forced state (like 6 during init or disconnection)
    var i,j;

    sim.changeState(w,s||0);

    w.currentInstruction=null;
    sim.stop(w);  // Stop if button pressed.

    w.cycle_id.innerHTML
      =w.cycle
      =w.address
      =w.result
      =s?"u":0;

    for (i in w.regs){
      w.regs[i]=null;
      w.regs_id[i].innerHTML="u";
      w.regs_hint[i]={};
      w.regs_id[i].id=""; //bgcolor
      (w.regs_histo[i]
         =j
         =dcE("DIV")
      ).nl=0;
    }

    sim.changeCarry(w,null);
    sim.changeZero(w,null);

    w.trace_id.innerHTML=""; // ZZZZzzzzapppp!
    w.traceLen
     =w.validRegs  // no valid register (none written yet).
     =0;
    w.logBuff="";

/* validRegs :
  bit 0 : PC
  bit 1-15 : registers
  bit 16 : carry
  bit 17 : Zero
*/
    sim.displayRegHistory(0,w);

    // Clear history

    sim.regWrite(w,0,0); // PC=0
    w.carry
   =w.zero
   =0;
    w.Carry_id.checked
   =w.Zero_id.checked
   =w.BPstop // No fault or breakpoint
   =false;

    sim.flushChanges(0,w);

    // read instruction memory and disassemble
    sim.instrLoad(w);
    sim.updateASM(w);
  },

  flushChanges: function(e,t) {
    var i, w=parentWin(t||this);
    for (i in w.regs)
      w.regs_changed[i].innerHTML="";  // flush the bullets
  },

  abort: function(w,n,e,t){ // Window, New state, Element to redify
    if (t)
      sim.traceLog(w,t);
    if (n>4)
      w.currentInstruction=null;
    sim.changeState(w,n); // update the logs as well
    w.BPstop=true;
    if (e)
      e.id="XX";
    return false;
  },

  instrLoad: function(w){
    var a, b, m=w.Map;
    // flush the changes
    for (var i=0;i<32;i++)
      w.regMod[i]=" ";  //    sim.mkLine(w);

    if (m) {
      // read/fetch instruction memory

      w.flags=0;
      w.instrLen=2;

      //get first half :
      if ((
        a=Map.MemRead(m, w.regs_hint[0],
           w.currentAddress=w.regs[0] & ~1, // even address
           w, 1) // eXecute
            )===null)
        return sim.abort(w,5,w.regs_id[0],"can't read instruction halfword@"+w.currentAddress);  // FAULT

      if (a&1) {
        w.instrLen=4;
        if ((
          b=Map.MemRead(m, w.regs_hint[0],
              w.currentAddress+2, w, 1) // eXecute
            )===null)
          return sim.abort(w,5,w.regs_id[0],"can't read instruction halfword@"+(w.currentAddress+2));  // FAULT
        a|=b << 16;
      }

      // Check the profile 
      if( !(w.regs_hint[0].w.memory.rwx & w.bpBits))
        sim.traceLog(w,"Incompatible datapath size (YASim="+w.bpBits+")");

      w.currentInstruction=a;
      w.opcode=
          (a&=252); // 63<<2
      if (!profiles[w.profileName].valid[a]){
        sim.traceLog(w,"This opcode is invalid for this profile");
        sim.changeState(w,5);  // FAULT
        w.BPstop=true;
      }
      w.flags=Y.opcode_table[a].flags;
      w.validRegs |= 1; // PC has a valid address
    }
    else
      w.currentInstruction=null;
  },

  updateASM:function(w){
    var a=w.currentInstruction;
      w.Disas_hex.innerHTML=int2hex(a);
      w.Disas_msg.innerHTML="";

    if(a!==null){
      if (profiles[w.profileName].valid[a&252]){ // 63<<2
        // disassemble the word
        Y.DISASM(a,w.DISASM);
        w.Disas_out.innerHTML=w.DISASM.instruction;
        w.Disas_out.style.backgroundColor=""; //default
      }
      else{
        w.Disas_out.style.backgroundColor="orange";
        w.Disas_out.innerHTML=I8N("asmie");
      }
    }
    else{
      w.Disas_out.style.backgroundColor="#777";
      w.Disas_out.innerHTML="u";
      w.Disas_msg.innerHTML=I8N(w.Map?"iia":"fcsm");
    }
  },

  multiread:{
         " ":"\u204E",
    "\u204E":"\u2051",
    "\u2051":"\u2042"
  },
  readReg:function(w, n, sym){
    n&=15;
    var b=sim.regIndexDisplay[n];

    if(w.validRegs & (1<<n)) {
      w.regMod[b]
         =  sym  // the forced symbol has priority
         || sim.multiread[ w.regMod[b] ] // "increment" with the table
         || "?";  // if unknown state
      return w.regs[n];
    }
    else {
      sim.traceLog(w,"attempt to read an invalid register "+Y.registers_names[n]);
      return null;
    }
  },

  // The instruction is already loaded by instrLoad
  oneStep: function(w) {
    var dst=-1, // NOT 0
       cond=true, // default
       condReg, condFunc,
       a=w.currentInstruction, b,
       c=Y.opcode_table[w.opcode],
       name=c.name,
       fx=c["action"+w.bpBits];

/* to do soon
    if (w.opcTraps[w.opcode]==true)
      return abort(w,3);  // STOP
*/

//    if (!profiles[w.profileName].valid[a])
//      return sim.abort(w,5);  // FAULT

    // read operands
     w.result
    =w.dst3
    =w.snd
    =w.si4
    =null;


/////////////////////////////////////////////////////////////
    // Conditions : see also yasep_conditions.js
    if (((a&3) == 3) && !(Y.NO_CONDITION & w.flags)) {
      condReg= (a >> 28) & 15; // Y.OFFSET_EXTSRC4 = 28;

      // read the condReg'th bit of R1:
      if (
           (condFunc= (a >> 22)&3)  // 1 + Y.OFFSET_EXTCOND = 21
         ==1) {
        // Read R1:
        if ((b=sim.readReg(w, 1))
             === null)
          return sim.abort(w,5);  // FAULT

        cond=(b >> condReg) & 1;
      }

      else {

        // Check one of 15 registers
        if (condReg!=0) {
          if ((b=sim.readReg(w, condReg))
             === null)
            return sim.abort(w,5);  // FAULT

          switch(condFunc) {
            case 0: // ZERO  => OK
              cond= (b==0); // shouldn't it be  cond=b ?
              break;

            case 2: // COND_LSB  => OK
              cond= b&1;
              break;

            case 3: // COND_MSB  => OK
              cond= 1 & (b >> (w.bpBits-1));
//          break;
          }
        }

        // Don't read if it's PC's implicit flags
        else {
          switch(condFunc) {
            case 0: // ALWAYS  => OK
              // Do nothing : already true
              break;

            case 2: // Carry  => KO :-(
              if ((1<<16) & w.validRegs)
                cond=w.carry;
              else
                return sim.abort(w,5,null, "Carry flag not written yet");  // FAULT
              break;

            case 3: // EQ
              if ((1<<17) & w.validRegs)
                cond=w.zero;
              else
                return sim.abort(w,5,null, "Zero flag not written yet");  // FAULT
//          break;
          }

        }
      }

      if (Y.FIELD_EXTNEG & a) // Final XOR
        cond=!cond;
    }

    if (cond){ // default: true
/////////////////////////////////////////////////////////////

      if (!(Y.IGNORE_SND & w.flags))
        if ((w.snd=sim.readReg(w, a>>8))  // Y.OFFSET_SND;
             === null)
          return sim.abort(w,5);  // FAULT
        else
          w.snd &= w.bpMask;

      if (!(Y.IGNORE_SI4 & w.flags)){
        if (a & 1){  // Y.FIELD_IMMREG  : Long form
          if (a & 2){ // Y.FIELD_EXTFORM : extended form
            if (a & Y.FIELD_EXTIMM4) { //  short immediate
              w.si4=(a>>12)&15; // short immediate
              if (w.si4 & 8)
                  w.si4|=~7; // sign extension
            }
            else // short register
              if ((w.si4=sim.readReg(w, a>>12))  // Y.OFFSET_SI4
                   === null)
                return sim.abort(w,5);  // FAULT
          }
          else // long immediate
            if (!(Y.IGNORE_IMM16 & w.flags)){
              w.si4=a>>16; // sign extension comes for free with the reframing
              if ((Y.IMM20 & w.flags) && (w.bpBits > 16)){
                w.si4&=F4; // remove the sign bits
                w.si4|=((a & 0xF00) // Y.FIELD_SND
                        << 20) // put the field in the MSB
                        >> 12; // shift back to extend the sign
              }
            }
        }
        else { // Short form
          if (a & 2){ // Y.FIELD_EXTFORM
            w.si4=(a>>12)&15; // short immediate
            if (w.si4 & 8)
                w.si4|=~7; // sign extension
          }
          else // short register
            if ((w.si4=sim.readReg(w, a>>12))  // Y.OFFSET_SI4
                 === null)
              return sim.abort(w,5);  // FAULT
        }

        w.si4 &= w.bpMask;
      }

      if (((a&3) == 3) // Long extended
       &&(Y.READ_DST3 & w.flags))
        if ((w.dst3=sim.readReg(w, a>>24))  // Y.OFFSET_DST2
             === null)
          return sim.abort(w,5);  // FAULT
        else
          w.dst3 &= w.bpMask;


      // execute
      if(typeof fx == "function")
        fx(w);
      else
        // check unhandled or invalid opcodes
        switch(name){
          case "NOP":
          case "CALL": // handled later
          case "CRIT":
            // Just ignore, do nothing
            break;

          case "HALT":
            return sim.abort(w,4);  // HALT

          default:
            if (name!="INV")
              sim.traceLog(w,"Opcode non géré");
            return sim.abort(w,5);  // FAULT
        }

    // write operands (if condition true)
    // if (cond || (Y.NO_CONDITION & w.flags)){

      if(!(Y.NO_WRITEBACK & w.flags)){ // What about ABORT_WRITE ?
             // 	SMAX SMIN UMAX UMIN already perform as expected so it's not used yet.

        if(name=="CALL"){  // "exchange" SI4 and PC :
          w.result=w.instrLen+w.currentAddress; // The result is the "next PC"
          w.instrLen=0;           // Alter the "next PC"
          w.currentAddress=w.si4;
        }

        if (a & 1){  // Y.FIELD_IMMREG
          if (a & 2) // Y.FIELD_EXTFORM
            dst=24;  // Y.OFFSET_EXTDST3
          else
            dst=12;  //Y.OFFSET_SI4;
        }
        else
          dst=8; // Y.OFFSET_SND;
        dst=(a >> dst)&15;
        if (! sim.regWrite(w, dst ,w.result))
          return;
      }

      // Carry, zero
      if (Y.CHANGE_CARRY & w.flags)
        sim.changeCarry(w,w.carry);
      if (Y.CHANGE_ZERO & w.flags)
        sim.changeZero(w,w.zero);
    }

    // display trace
    sim.logLine(w);

    // check cycle breakpoints
    if (w.cycleTraps[
      w.cycle_id.innerHTML
        =++w.cycle
          ]==true)
      return abort(w,3);  // STOP

    // writeback PC (if not already modified)
    // check address breakpoints => incorporated in PC writeback
// if... == " "
    if (dst != 0) // advance PC but don't overwrite if dst=0
      sim.regWrite(w,0,w.instrLen+w.currentAddress); // This write will not trigger the "change" flag because it is reset just after
        // furthermore, the result is not tested because it won't FAULT. That happens at the next step:
    sim.instrLoad(w); // flush the modify flags
  },

  runNext:null,

  insertRun:function(w,s){
    w.BPstop=false;
    sim.changeState(w,s);
    var a=sim.runNext;
    if (a){
      var p
        =w.runNext=a.runNext;
                   a.runNext=w;
         w.runPrev=p.runPrev;
                   p.runPrev=w;
    }
    else{ // init the circular list
      sim.runNext
       =w.runNext
       =w.runPrev
       =w;
      redraw(sim.multiRun);
    }
  },

  stop:function(w){
    if (w.state<3) // INIT, STEP or RUN (don't let DISCONNECTED, HALT or FAULT restart the whole thing)
      sim.changeState(w,3); // "STOP"

    var n=w.runNext;
    if(n){ // may be undefined
      if(w==n)
        sim.runNext=null;
      else {
        if(w==sim.runNext)
          sim.runNext=n;
        var a=w.runPrev;
        a.runNext=n;
        n.runPrev=a;
      }
      w.runNext=
      w.runPrev=null;
    }

    sim.updateASM(w);
  },

  buttonReset:function() {
    var w=parentWin(this);
    if(w.state<6) // don't force if it's disconnected
      sim.resetState(w);
  },

  buttonStop:function() {
    sim.stop(parentWin(this));
  },

  buttonStep: function() {
    var w=parentWin(this);
    if(w.state<4){  // don't let DISCONNECTED, HALT or FAULT restart the whole thing
      sim.stop(w);
      sim.oneStep(w);
      sim.updateASM(w);
    }
  },

  buttonMultiStep: function(e,t) {
    var w=parentWin(t||this);
    if (w.state<4) {
      sim.stop(w);
      w.skipCount=w.skipCycles;
      sim.insertRun(w,1); // "STEP"
    }
  },

  buttonRun: function(e,t) {
    var w=parentWin(t||this);
    sim.stop(w);
    if (w.state<4)
      sim.insertRun(w,2);// "RUN"
  },

  multiRun: function(){
    if (sim.runNext) {
      var d=+new Date()+500, // each lot of steps is 500ms
          w=sim.runNext;
      do {
        sim.oneStep(w);
        if (w.BPstop || (w.state==1 && (--w.skipCount <1)))
          return sim.stop(w);

        sim.runNext
          =w   // follow the linked list and do the backup in case it gets interrupted
          =w.runNext;
      } while(d> +new Date());

      // update the asm output,
      // scan the ring once
      w=sim.runNext;
      do {
        sim.updateASM(w);
        w=w.runNext;
      } while (w!=sim.runNext);

      redraw(sim.multiRun);
    }
  },

////////////////////////////////////////////

///////////// Profiles :
  change_profile: function(a,w) {
    var l, m=0,
        t=this,
        found=false;

    if(typeof a!="string"){
      // when called from changing the selector
      if(w)
        t=w.ProfileSel;
      else
        w=parentWin(t);
      a=t.options[t.selectedIndex].text;
    }
    else {
      if (typeof profiles[a]!="object")
        return Al8N("Ipn");
      var i,sel=w.ProfileSel;
      for (i in sel.options) {
        if (sel.options[i].text==a) {
          found=true;
          break;
        }
      }
      if (!found) {
        // new profile added by the user since last click ?
        i=sel.options.length;
        sel.options[i]=new Option(a);        
      }
      sel.selectedIndex=i;
    }
    w.profileName=a;

    a=profiles[a].datapath;
    if (w.bpBits != a) {
      w.algnMask=
        a==16 ? -2 : -4;
      w.DISASM.YASEP_TYPE
        =w.bpBits
        =a;
      while (a--)  // iterative mask creation because
        m+=m+1;    // 1<<32 == 1 !!! (5 LSB kept)
      w.bpMask=m;

      // check all the inputs under w.BPdiv, in case they are now out of range
      l=w.BPdiv.getElementsByTagName("INPUT");
      for (b in l)
        if (l[b].id=="num")
            l[b].onkeyup();

//    update/redraw register values with new mask
      sim.redisReg(w);

//  this could change the cursor position in YASMed !
    }
  },

  update_proflist:function(u,t) {
    t=t||this;
    var p,s=t.selectedIndex,i=0;

    for (p in profiles) {
      // the position is reset to 0 each time the list is changed,
      // which makes some weird visual inconsistencies,
      // so update only if really needed (but does not really solve the "bug")
      // listBlur helps too.
      if (!t.options[i] || (t.options[i].text!=p))
        t.options[i]=new Option(p);
      i++;
    }
    t.selectedIndex=s>0?s:0; // by default s is -1 ?...
  },

  listBlur:function(){ // prevents a visual bug...
    var w=parentWin(this);
    sim.change_profile(w.profileName,w);
  },


/////////////// Radix
  chBase: function(t){
    var i, w=parentWin(t);
    w.num_func=sim["num_"+t.value];
    sim.redisReg(w);
  },

  num_bin: function(n,d){
    return toBin(n,d,1)+"b";
  },

  num_dec: function(n){
    return n;
  },

  num_hex: function(n){
    return int2hex(n);
  },

  redisReg: function(w){
    var r;
    for (i in w.regs){
      r=w.regs[i];
      w.regs_id[i].innerHTML=
         r!==null ? w.num_func(w.regs[i] & w.bpMask, w.bpBits) : "u";
    }
  },

/////////////// Register history

  displayRegHistory: function(n,w){
    if (!w){
      n=this.nr;
      w=parentWin(this);
    }
    w.regName.innerHTML=Y.registers_names[n];
    var f=w.HistoDiv;
    if(f.firstChild)
       rC(f.firstChild);
    f.appendChild(w.regs_histo[n]);
  },

  regIndexDisplay:[
    0, 2, 4, 6, 8, 10, // PC, R1-R5
    20,30,18,28,16,26,
    14,24,12,22 
  ],

////////////// Register write
  regWrite: function(w,r,v, sym, dis) {
// Win
// Register
// Value
// symbol (to display)
// DISable (when a write to Dx must not trigger a memory fetch)

//    if(typeof r!="number")
//      sim.traceLog(w,"invalid register name:"+r);
    r&=15; // check that r >= 0 and <16
    var rs=1<<r;

//    // if equal, don't log ?
//    if(w.regs[r]!=v){
//  NO so that aliasing can be "solved" by reloading the address register
//  (and it's quite uncommon to write the same value multiple times
     w.regs_id[r].id="";

    if(v!==null){
      v&=w.bpMask; // check that value >= 0 and <= bitMask
      if (!r) {   // The LSB of the PC is always 0:
        if (v&1)
          sim.traceLog(w,I8N("awPL"));
        v&= ~1; // clear LSB
      }
      w.validRegs |= rs;
    }
    else
      w.validRegs &= ~rs;

    // update the register value in w.regs
    w.regs[r]=v;

    var a, b, c, d,i,j, m=w.Map,
    // display the value
      n =w.regs_id[r].innerHTML
        = (v===null)? "u":w.num_func(v,w.bpBits);

    if (r>=6) { // address/data register ?
       a=r^1;  // the "other" register of the pair

       // Change the background color if it's a A register that is parked
       if(r&1){ // A register ?
/*       { // compute the parking address
          var p=r>>1, b="";
          if (v== p|(w.bpMask&~7))
            b="P";
          w.regs_id[r].id=b;
        } */

        if (v===((w.bpMask&~7)|(r>>1)))
          w.regs_id[r].id="P";

        if(v!==null){
          // read memory
          v &= w.algnMask; // Align the address

          if ((
            b=Map.MemRead(m, w.regs_hint[r],
                v, w, 4) // data Read
               )===null) {
//            b=null;  // already true
            w.regs_id[r].id="XX";
            w.validRegs &= ~rs;
          }
          else
            if (w.bpBits > 16){
              if ((
                c=Map.MemRead(m, w.regs_hint[r],
                    v+2, w, 4) // data Read
                   )===null) {
                b=null;
                w.regs_id[r].id="XX";
                w.validRegs &= ~rs;
//                return sim.abort(w,5,w.regs_id[r]);  // FAULT
              }
              else
                b |= c << 16;
            }
//          sim.regWrite(w, a, b&w.bpMask,"\u25B2");
        }
        else // v===null
          b=v;
        sim.regWrite(w, a, b,"\u25B2", true); // b can be null to invalidate the D register
      }
      else{ // D register

        if((v!==null) &&(dis!==true)){ // Just don't bother if it's null

          // But check that the A is valid !
          if (w.validRegs & (1<<a)) {

            // write to memory
            b=w.regs[a] & w.algnMask; //  get and align the address

            if   ( Map.MemWrite(m, w.regs_hint[a], b, w, v&F4)
                     ===null)
              return sim.abort(w,5,w.regs_id[a], "can't write memory");  // FAULT

            if (w.bpBits > 16)
              if ( Map.MemWrite(m, w.regs_hint[a], b|2, w, v>>>16)
                     ===null)
                return sim.abort(w,5,w.regs_id[a],  "can't write memory");  // FAULT
          }
          else
            return sim.abort(w,5,w.regs_id[a], "can't write memory: invalid address");  // FAULT

        } // !==null
      }// D
    } // A/D ?
//    else // Normal register
//      w.validRegs |= rs;


      // update the trace log

      //toggle the "changed" flag
      w.regMod[sim.regIndexDisplay[r]+1]
        =w.regs_changed[r].innerHTML
        =sym||"\u25CF";


      // update the register log
      i=w.regs_histo[r];
      j=i.nl;
      if(w.traceMax){
        j++;
        (d=dcE("DIV")).innerHTML
           =pad_left(w.cycle,10)
           +pad_left(w.currentAddress,12)
           +"  "+pad_left(n,10);
        w.regs_histo[r].appendChild(d);
      }

      while(j>w.traceMax){
        rC(i.firstChild);
        j--;
      }
      i.nl=j;

      // scan the breakpoint list

//    }
    return true;
  },

  checkRegister:function(t){
    if(t.value=="u")
       t.value=0;
    var n
      =sim.numval
      =str2int(t.value),
    w=sim.pw||(sim.pw=parentWin(edit_text.current_elem)),
    m=w.bpMask+1;
    edit_text.valid=!((n===null)||(n>=m)||(n<(m/-2)));
  },

  validRegister:function(t){ // normally, the sim.numval is correct because save is turned on when valid==true
    sim.regWrite(sim.pw, t.rn, sim.numval,"\u25C6");

    if(t.rn==0){ // PC ?
      if (w.state<5) // INIT, STEP or RUN (don't let DISCONNECTED restart the whole thing)
        sim.changeState(w,3); // "STOP"
      sim.instrLoad(sim.pw);
      sim.updateASM(sim.pw);
    }

    // erase source so innerHTML will be re-read next time after update by sim
    t.source
      =sim.pw
      =null;

  },
/*
////////////// Carry & Zero
///          e.onchange=sim["click"+name];
///          td.onclick=sim["display"+name];
*/
  changeCarry:function(w,v) {
    if (v===null){
      w.validRegs &= ~(1<<16);
      w.Carry_id.disabled=true;
    }
    else{
      v=(v==true);
      w.Carry_id.disabled=false;
      w.Carry_id.checked
       =w.carry
       =v;
      w.validRegs |= 1<<16;
    }
  },

  changeZero:function(w,v) {
    if (v===null){
      w.validRegs &= ~(1<<17);
      w.Zero_id.disabled=true;
    }
    else{
      v=(v==true);
      w.Zero_id.disabled=false;
      w.Zero_id.checked
       =w.zero
       =v;
      w.validRegs |= 1<<17;
    }
  },

  clickCarry:function(v) {
    var w=parentWin(this);
    sim.changeCarry(w, w.Carry_id.checked);
  },

  clickZero:function(v) {
    var w=parentWin(this);
    sim.changeZero(w, w.Zero_id.checked);
  },

/////////////// breakpoints (low level API)
/*
 // TODO : detect duplicate breakpoints

  addBr_cycle:function(w,cycle) {
  },

  addBr_addr:function(w,addr) {
  },

  addBr_valReg:function(w,val,reg) { // passe la valeur en négatif
  },

  toggleBr:function(w,br) { // passe la valeur en positif / négatif
  },

  deleteBr:function(w,br) {
  },

  changeBPval:function(w,br,val) {
  },

  changeBPreg:function(w,br,reg) {
  },
*/
/////////////// breakpoints display / interface

  addNewBP:function(d){
//    v.stopPropagation();
    var e,f;
    (e=dcE("DIV")).className="BPitem";
     e.id="off";

       f=dcE("DIV");
       f.className="minus";
       f.onclick=sim.deleteBP;
       f.title=I8N("dtb");
     e.appendChild(f);

       f=dcE("INPUT");
       f.type="checkbox";
       f.title=I8N("edtb");
       f.onchange=sim.click_toggleBr;
     e.active_id=f;
     e.appendChild(f);

    d.appendChild(e);

    //    d.style.display="block"; replaced by selective clicking:
    if(d.style.display!="block")
      d.previousSibling.spanShow.onclick();

    d.total_id.innerHTML= ++d.total;
    return e;
  },

  checkNumber: function(ev){
    var t=this,
      d=t.parentNode,
      w=parentWin(d),
      m=w.bpMask+1,
      n=str2int(t.value);
      a=d.active_id;
    // disables the breakpoint
    if(a.checked){
       a.checked=false;
       a.onchange();
     // note : it can be de-checked only if it was checked before,
     // meaning that t.parentNode.number was != null
     // so click_toggleBr executes the correct branch
     // (even when we just cleared the box)
    }
    if ((n===null)||(n>=m)||(n<(m/-2))) {
      n=null;
      t.style.backgroundColor="#F65";
    }
    else
      t.style.backgroundColor="";
    t.parentNode.number=n;
  },

  addNumberField:function(){
    var e=dcE("INPUT");
    e.id="num";
    edit_text.register(e, {
      size:10, maxsize:33,
      defaultValue: "0",
      func:sim.checkNumber
    });
    return e;
  },

  deleteBP:function(e,t){
    t=(t||this);
    var u=t.parentNode, // the breakpoint div
        d=u.parentNode; // container div
    d.total_id.innerHTML= --d.total;
    if (t.nextSibling.checked)
      d.active_id.innerHTML= --d.active;
    rC(u);
  },

  click_addBr_cycle:function(e,t) {
    var w=parentWin(t||this),
        i=w.BPcycle_id,
        d=sim.addNewBP(i);
    d.appendChild(sim.addNumberField());
  },

  click_addBr_addr:function(e,t) {
    var w=parentWin(t||this),
        i=w.BPaddr_id,
        d=sim.addNewBP(i);
    d.appendChild(sim.addNumberField());
  },

  click_addBr_valReg:function(e,t) { // passe la valeur en négatif
    var w=parentWin(t||this),
        i=w.BPvalReg_id,
        j,s,
        d=sim.addNewBP(i),
        r=I8N("comp").split(" ");

    d.appendChild(s=sim.regSel.cloneNode(true));
    s.selectedIndex=1;

    s=dcE("SELECT");
    for (j in r)
      sim.relSel.options[j]=new Option(r[j]);
    d.appendChild(s);
    s.selectedIndex=2;
    d.appendChild(sim.addNumberField());
  },

  click_addBr_opc:function(e,t) {
    var w=parentWin(t||this),
        i=w.BPopc_id,
        j,k=0,
        v=[],
        s=dcE("SELECT"),
        d=sim.addNewBP(i);
    for(j in profiles[w.profileName].valid_instructions)
      v.push(j);
    v.sort();
    for(j in v)
      s.options[k++]=new Option(v[j]);
    d.appendChild(s);
  },

  click_toggleBr:function(e,t) { // passe la valeur en positif
    t=t||this;
    var p=t.parentNode,
        d=p.parentNode;
    if(p.number!==null){ // 
      d.active_id.innerHTML // houba !
        =(d.active+= t.checked?1:-1);
/*
      if (t.checked){
// activate the proper BP with the new value

      }
      else{
// disables
      }
*/
    }
    else // trying to click when invalid?
      t.checked=false; // force the checkbox back
  },
/*
  click_deleteBr:function(e,t) {
    t=t||this;
  },
*/

//////////////////////////////////////////////////////////////////////////////////////////
// trace

  traceLog:function(w, msg){
    w.logBuff+="\n"+WARN+msg;
  },

  logLine:function(w){
    var i=w.traceLen+1,
     j=w.currentInstruction & 252,
     o=Y.opcode_table[j],
     f=dcE("DIV");
     f.innerHTML=pad_left(w.cycle,9)
         +pad_left(w.currentAddress,11) //" 4294967296"
         +pad_left(o?o.name:("("+j+")"),6)
         +" "+w.regMod.join("")+" c Z"
         +pad_left(w.result,12)
         +w.logBuff;
    w.logBuff="";
    w.trace_id.appendChild(f);
    w.trace_id.scrollTop=w.trace_id.scrollHeight;
    w.HistoDiv.scrollTop=w.HistoDiv.scrollHeight;
    // flush oldest traces
    while(i>w.traceMax){
      rC(w.trace_id.firstChild);
      i--;
    }
    w.traceLen=i;
  },

// for changing the trace depth :
  checkTraceMax:function(t){
    var  n
      =sim.numval
      =str2int(t.value);
    edit_text.valid=((n!==null)&&(n>=0));
  },

  validTraceMax:function(t){ // normally, the sim.numval is correct because save is turned on when valid==true
    parentWin(edit_text.current_elem).traceMax = sim.numval;
    // erase source so innerHTML will be re-read next time after update by sim
    t.source=null;
    // flush excedent : the while() in logLine
  },

//////////////////////////////////////////////////////////////////////////////////////////

  eraseCallback:function(w){
    Map.delSim(w); // calls stop
  },

/////////////// Building a window
  start: function() {
    var cont=dcE("DIV"),
      w = ygwm.new_window(
         "YASim "+sim.simCount, null, cont,
         600, 700, 40, 70, false, true, true, true, false, "ms2_yelo"),
      c, d, f, i, p, tt,tb,tr,td, sel=dcE("SELECT");

//    w.bpMask=F4;  set at the end by a call to change_profile
//    w.bpBits=16;
//    w.algnMask...

    w.eraseCallback=sim.eraseCallback; // In case we close the window during a simulation run
    w.Map=null;

    w.regs=[];
    w.regs_histo=[];
    w.regs_id=[];
    w.regs_hint=[];
    w.regs_changed=[];
    w.regMod=[];

    Y.opcodeInterface(w);

/////// Top :

    (e=w.arrowDiv=dcE("DIV")).className="tagArea";
/////     e.title=I8N("DDax"); //////////////////////////// To be restored later
     e.appendChild(
         w.arrow=sim.create_cursor("red",sim.simCount,null,w));
    e.style.display="none"; // hidden when not disconnected
    cont.appendChild(e);

    w.state=sim.INIT;
      d=dcE("DIV");
      button(d,"\u21E4",sim.buttonReset,"Reset"); //x21E4 ⇤ reset
      button(d,"\u25B6",sim.buttonRun,"Run");         //x25B6 ▶  run
      button(d,"\u25FC",sim.buttonStop,"Stop");        //x25FC ◼ stop
// other : \u2933  ⤳  skip over function calls
      button(d,"\u21B7",sim.buttonStep,"Step");        //x21B7 ↷ step
      button(d,"\u21B7\u21B7\u21B7",sim.buttonMultiStep,"mStp");

      (e=dcE("SPAN")).innerHTML="&nbsp;"+I8N("stp");
      d.appendChild(e);
      d.appendChild(e=dcE("INPUT"));
      edit_text.register(e, {
        size:5, maxsize:5,
        defaultValue: "10",
        func: function(ev){
          var t=this;
          edit_text.filter_number(t);
          var n=str2int(t.value);
          if (n<2)
              n=2;
          parentWin(t).skipCycles
            =t.value
            =n;
        }});
    w.skipCycles=10;

      (e=dcE("SPAN")).innerHTML="&nbsp;"+I8N("Cycle")+"&nbsp;#";
      d.appendChild(e);
      d.appendChild(w.cycle_id=dcE("SPAN"));
    cont.appendChild(d);

/// Disassembler
      (e=dcE("DIV")).innerHTML=I8N("Instruction")+':&nbsp;<span id="hex">u</span>=<a style="cursor:pointer" class="asm_active" id="disas" onclick="wa(\'ASM/asm#a?\'+this.innerHTML)"> </a> &nbsp; <span id="msg"></span>';
      (w.Disas_div=e).style.margin="2px";
    d.appendChild(e);
     w.Disas_out=getById("disas","A",e);
     w.Disas_hex=getById("hex","SPAN",e);
     w.Disas_msg=getById("msg","SPAN",e);

    w.DISASM= new Y.DISASM_context(function(col,msg){ // closure, but can't avoid it simply
      if(col!="blue"){
        w.Disas_out.style.backgroundColor=col;
        w.Disas_msg.innerHTML=msg;
      }
    });


/////// Configuration

    (d=dcE("DIV")).appendChild(Map.createMapSel(w));

      (e=dcE("DIV")).innerHTML=I8N("TrD")+':<span id="traceMax"></span> &nbsp; '+I8N("prf")+":&nbsp;";
      // profile selector
      sel.onblur=sim.listBlur;
      e.appendChild(
        w.ProfileSel=sel);
    d.appendChild(e);
 
    (f=getById("traceMax","SPAN",e)).title=I8N("TrDt");
/*    f.innerHTML
      =w.traceMax
      =20;*/
    edit_text.register(f, {
      size:4, maxsize:4,
      defaultValue:
        f.innerHTML
         =w.traceMax
         =20,
      check: sim.checkTraceMax,
      func:  sim.validTraceMax
    });

/*
// source :
        (e=dcE("DIV")).innerHTML="Source : ☑JS <strike>GHDL</strike> <strike>YCD</strike>";
      d.appendChild(e);

 // JS: selecteur de YASMed
 // GHDL
 // YCD

// import/export config
*/

    h3(cont,d,"cnf");


/////// Registers

      (tt=dcE("TABLE")).style.fontFamily="monospace";
       tt.style.textAlign="right";
       tt.style.borderSpacing="0px";
       tt.appendChild(tb
         =dcE("TBODY"));
       c='<th onclick="sim.flushChanges(0,this)" title="'+I8N("fcm")
         +'"style="cursor:pointer">\u2260</th><th>Reg</th><th>'+I8N("val")+'</th><th>&nbsp;</th>';
       (tr=dcE("TR")).innerHTML=c+c;
       tb.appendChild(tr);

       for (i in Y.registers_names){
         w.regs[i]=null;
         c=Y.registers_names[i];
         if(!(+i & 1))
           tr=dcE("TR");

           (td=dcE("TD")).className=c[0];
         tr.appendChild(
              w.regs_changed[i]=td);

           (td=dcE("TD")).className=c[0];
           td.innerHTML=c+":";
           td.title=I8N("cvlv");
           td.style.cursor="pointer";
           td.nr=+i; //passes the argument through "this"
           td.onclick=sim.displayRegHistory;
           td.style.padding="1px";
         tr.appendChild(td);

           (td
             =w.regs_id[i]
             =dcE("TD")).className=c[0];
//           td.innerHTML="u"; // change_profile calls redisReg  will be removed soon thanks to initialisation
           edit_text.register(td, {
             size:10, maxsize:33,
             defaultValue: "0",
             check: sim.checkRegister,
             func:  sim.validRegister
           });
           td.rn=i; // used later so the proper register gets written
         tr.appendChild(td);

         tr.appendChild(dcE("TD"));

         if(+i & 1)
           tb.appendChild(tr);
       };

      function flag(name){
        tr.appendChild(dcE("TD"));
           (td=dcE("TD")).colSpan=2;
          td.innerHTML=name+":";
          (e=dcE("INPUT")).type="checkbox";
          e.onchange=sim["click"+name];
//          td.onclick=sim["display"+name];
          td.style.cursor="pointer";
          td.appendChild(
             w[name+"_id"]=e);
        tr.appendChild(td);
        tr.appendChild(dcE("TD"));
      }

      tr=dcE("TR");
        flag("Carry");
        flag("Zero");
      tb.appendChild(tr);

      (e=dcE("DIV")).appendChild(tt);
       e.style.position="relative";
       e.style.cssFloat="left";
      (d=dcE("DIV")).appendChild(e);

      d.appendChild(e=dcE("FORM"));
        e.style.fontSize="70%";
        f='<input type="radio" name="rb" onclick="sim.chBase(this)" value=';
        e.innerHTML=I8N("rdx")
           +f+'"bin"/> bin&nbsp;'
           +f+'"dec"/> dec&nbsp;'
           +f+'"hex" checked="checked"/> hex';

      d.appendChild(e=dcE("DIV"));
       e.id="histoReg";
       e.innerHTML='<u>'+I8N("ho")+' <span id="regName"></span>:</u><br>   cycle     '
           +pad_left(I8N("adr"),8)+'    '+pad_left(I8N("val"),7)+'<div id="HistoDiv"></div>';
       w.regName=getById("regName","SPAN",e);
       adjustHeight(w.HistoDiv
          =getById("HistoDiv","DIV",e),100);

    h3(cont,d,"rgs");
    w.num_func=sim.num_hex;

/////// Breakpoints
      function newBP(text,fun,i){
        (f=dcE("DIV")).className="simBP";
        var g=dcE("DIV");
           g.onclick=fun;
           g.className="plus";
           g.title=I8N("Canb");
         f.appendChild(g);

          (g=dcE("SPAN")).innerHTML='<span>\u25BD</span>&nbsp;<i>(<span id="active"></span>/<span id="total"></span>)</i>&nbsp; '+I8N(text)+" :";
           g.onclick=showhideNext;
           g.title=I8N("ctsh");
           g.style.cursor="pointer";
           f.spanShow=g; ////!!!
         f.appendChild(g);

        d.appendChild(f);
        d.appendChild(g
           =w[i]
           =dcE("DIV")); // The sub-div
         g.style.display="block";
         (g.active_id=getById("active","SPAN",f)).innerHTML=g.active
        =(g.total_id =getById("total" ,"SPAN",f)).innerHTML=g.total
           =0;
      }

      w.opcTraps=[];
      w.cycleTraps=[];

      (w.BPdiv
        =d
        =dcE("DIV")).style.display
                         ="block";
        newBP("sac",sim.click_addBr_cycle,   "BPcycle_id");                // blacklist(BPcycle_id)....
        newBP("saia",sim.click_addBr_addr,   "BPaddr_id");
        newBP("sorw",sim.click_addBr_valReg, "BPvalReg_id");
        newBP("sopc",sim.click_addBr_opc,    "BPopc_id");
    h3(cont,d,"brk",d);

////////////////// Trace

       (d=dcE("DIV")).style.fontFamily="monospace";
    // The fixed header
       d.style.whiteSpace="pre";
         f='<span style="background-color:#';
         i='</span>';
       d.innerHTML='<div style="position:absolute;top:-1.3em;right:1em;cursor:pointer;background-color:#DFD"'
+' title="'+I8N("shms")+'" onclick="toggle(this.nextSibling)">'+I8N("lgd")+'</div>'
+'<div style="display:none;border:2px solid #dedefa">'
+I8N("lgnd")+'</div>'
// The actual header :
+'<div>    cycle    address  opc  PC'
+f+'A0A0D0">R1R2R3R4R5'+i
+f+'D0A0A0">D1D2D3D4D5'+i
+f+'A0D0A0">A1A2A3A4A5'+i+' C Z   value</div>';

     // The scrolling contents
      d.appendChild(
         w.trace_id=dcE("DIV"));
    h3(cont,d,"trc", w.trace_id,150);

///////////////////////////////////////////////
// The end :
    cont.appendChild(dcE("HR"));

///////////////////////////////////////////////

    // done at the end so it updates the display
    (sel.onfocus=sim.update_proflist)(0,sel);
    (sel.onchange=sim.change_profile)(0,w); // calls sim.redisReg(w);
    sim.resetState(w,6);   // force "DISCONNECTED"
    w.simCount=sim.simCount++;

///////////////////////////// ugly dev stuff here /////////////////////////////

////////// créer un breakpoint par programme ici :


//////////// send test signals :

/*
     (d=dcE("BUTTON")).innerHTML="add trace";
     d.onclick=function(){
       sim.logLine(w);
     };
   h3(cont,d,"ctl");

  sel.disabled=true;// when using an external core
  sim.change_profile("microYASEP",w);
  sim.updateASM(w,0x84); // triggers an error
*/
    return w;
  },

  init_obj: function(){
    sim.regSel=dcE("SELECT");
    for (var i in Y.registers_names)
      sim.regSel.options[i]=new Option(Y.registers_names[i]);

    menu.subMenuItem(menu.list["Tools"],i8n.sim, "tool/YASim");
  }

});
